package com.fractalite.hermes.teldar.services;


import java.math.BigInteger;
import java.security.KeyManagementException;
import java.security.NoSuchAlgorithmException;
import java.security.SecureRandom;
import java.text.ParseException;
import java.util.Currency;
import java.util.Random;

import javax.xml.datatype.DatatypeConfigurationException;

import org.apache.camel.Exchange;
import org.apache.camel.InvalidPayloadException;
import org.apache.camel.Processor;
import org.apache.commons.lang.RandomStringUtils;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;


public abstract class TeldarServices  implements Processor {
	//protected static Logger logger = LoggerFactory.getLogger(RestelServices.class);
	final String language="FRA";
	final Currency outputCurrency=Currency.getInstance("MAD");

	public TeldarServices() {
		
	}
	
	@Override
	public abstract void process(Exchange exchange) throws InvalidPayloadException, DatatypeConfigurationException, ParseException,KeyManagementException, NoSuchAlgorithmException ;
	
	public static String getCodeRoomType(int nbreOfAdult, int nbreOfChild) {
		
		String codeRoomType="";	
		switch (nbreOfAdult) {
         case 1:  codeRoomType = "SG";//DU
                  break;
         case 2:  codeRoomType = "DB";//D8,TW
                  if(nbreOfChild==1)
                	  codeRoomType="TN";
                  break;
         case 3:  codeRoomType = "TP";//TL
                  break;
         case 4:  codeRoomType = "CD";//C-
                  break;
		}
		return codeRoomType;		
	}
	
	public static int getRandomInt(int min, int max) {
		
		Random randomGenerator = new Random();
		int  nbre = max - min + 1;
		
		return min + Math.abs(randomGenerator.nextInt()) % nbre;
    }
	
	public static String getRandomString() {
		
		return "AV" + System.currentTimeMillis()%1000000;
    }
	
	
}
